#pragma once
#include "common.hpp"

class WaterHeater;

class Observer    // ۲ߵĳ
{
public:
	virtual void Update(WaterHeater* waterHeater) const = 0;
};

class WashingMode :public Observer      // ۲
{
public:
	virtual void Update(WaterHeater* waterHeater) const;
};

class DrinkingMode :public Observer     // ۲
{
public:
	virtual void Update(WaterHeater* waterHeater) const;
};

class WaterHeater        // ۲   
{
public:
	WaterHeater(int temperature = 25) :m_temperature(temperature) {};

	int getTempetature();
	void setTemperature(int temperature);

	virtual void HandleObserver();        // ֪ͨ۲
	bool RegisterObserver(Observer* inObserver);      // Ӽ۲죩
	bool UnRegisterObserver(Observer* inObserver);    // ɾ۲죩

protected:
	int m_temperature;
	vector<Observer*> m_Observers;
};
