#pragma once
#include "common.hpp"

class Subject      // ĳ
{
public:
	Subject(string name) :m_Name(name) {};
	string getName();
	virtual void request() = 0;

private:
	string m_Name;
};

class RealSubject :public Subject      // 
{
public:
	RealSubject(string name) :Subject(name) {};
	void request();

};

class ProxySubject :public Subject		// 
{
public:
	ProxySubject(string name, RealSubject* subject = nullptr) :Subject(name), m_pSubject(subject) {};
	void request();
	void preRequest();
	void afterRequest();

private:
	RealSubject* m_pSubject;
};