#include "decorate.hpp"

void Person::wear()
{
	cout << "װ" << endl;
}

string Engineer::getSkill()
{
	return m_Skill;
}

string Teacher::getTitle()
{
	return m_Title;
}

void Teacher::wear()
{
	cout << "" << m_Name << m_Title << endl;
	Person::wear();
}

void Engineer::wear()
{
	cout << "" << m_Skill << "ʦ " << m_Name << " " << endl;
	Person::wear();
}

ClothingDecorator::~ClothingDecorator()
{
	if (m_pPerson != nullptr)
	{
		delete m_pPerson;
	}
}

void ClothingDecorator::wear()
{
	m_pPerson->wear();
	decorate();
}

void CasualPantDecorator::decorate()
{
	cout << "һɫп" << endl;
}

void BeltDecorator::decorate()
{
	cout << "һɫͷúɫ" << endl;
}

void LeatherShoesDecorator::decorate()
{
	cout << "һ˫ɫƤЬ" << endl;
}

void KnittedSweaterDecorator::decorate()
{
	cout << "һϺɫ֯ë" << endl;
}

void WhiteShirtDecorator::decorate()
{
	cout << "һɫ" << endl;
}

void GlassesDecorator::decorate()
{
	cout << "һκڿ۾" << endl;
}


