#include "iterator.hpp"

vector<string> NumeralSystem::m_clinics = vector<string>{ "1", "2", "3" };;
string Customer::getName()
{
	return m_name;
}

void Customer::Regist(NumeralSystem* system)
{
	system->pushCustomer(this);
}

void Customer::setNum(int num)
{
	m_num = num;
}

int Customer::getNum()
{
	return m_num;
}

void Customer::setClinic(string clinic)
{
	m_clinics = clinic;
}

string Customer::getClinic()
{
	return m_clinics;
}

bool NumeralIterator::next()
{
	if (m_curIdx < (int)m_data.size() - 1)
	{
		m_curIdx++;
		return true;
	}
	return false;
}

Customer* NumeralIterator::current()
{
	return m_curIdx < m_data.size() ? m_data[m_curIdx] : NULL;
}

void NumeralSystem::pushCustomer(Customer* pCustomer)
{
	pCustomer->setNum(m_curNum + 1);
	string click = NumeralSystem::m_clinics[m_curNum % NumeralSystem::m_clinics.size()];
	pCustomer->setClinic(click);

	m_curNum++;
	m_pCustomers.push_back(pCustomer);
	cout << pCustomer->getName() << " ã" << m_name << "ɹҺţţ" << 
		pCustomer->getNum() << "ĵȴ" << endl;
}

NumeralIterator NumeralSystem::getIterator()
{
	return NumeralIterator(m_pCustomers);
}
