#include "observe.hpp"

int WaterHeater::getTempetature()
{
	return m_temperature;
}

void WaterHeater::setTemperature(int temperature)
{
	m_temperature = temperature;
	cout << "ǰˮ " << temperature << " " << endl;
	HandleObserver();
	return;
}

bool WaterHeater::RegisterObserver(Observer* inObserver)
{
	vector<Observer*>::iterator iter = find(m_Observers.begin(), m_Observers.end(), inObserver);
	if (iter == m_Observers.end())
	{
		m_Observers.push_back(inObserver);
		return true;
	}
	return false;
}

bool WaterHeater::UnRegisterObserver(Observer* inObserver)
{
	vector<Observer*>::iterator iter = find(m_Observers.begin(), m_Observers.end(), inObserver);
	if (iter != m_Observers.end())
	{
		m_Observers.erase(iter);
		return true;
	}
	return false;
}

void WaterHeater::HandleObserver() 
{
	for (vector<Observer*>::iterator iter = m_Observers.begin(); iter != m_Observers.end(); iter++)
	{
		(*iter)->Update(this);
	}
	return;
}

void WashingMode::Update(WaterHeater* waterHeater) const
{
	if (waterHeater->getTempetature() >= 50 && waterHeater->getTempetature() < 70)
	{
		cout << "ˮպã¶ãϴˡ" << endl;
	}
	return;
}

void DrinkingMode::Update(WaterHeater* waterHeater) const
{
	if (waterHeater->getTempetature() >= 100)
	{
		cout << "ˮտˡ" << endl;
	}
	return;
}
