#include "singleton.hpp"

SingletonA* SingletonA::m_pInstance = nullptr;

SingletonA* SingletonA::getInstance()
{
	if (m_pInstance == nullptr)
	{
		m_pInstance = new SingletonA();
	}
	return m_pInstance;
}

SingletonB* SingletonB::getInstance()
{
	static SingletonB Instance;
	return &Instance;
}
